۴ – راه اندازی دیتابیس PostgreSQL و اتصال به پروژه جنگو

۴ – راه اندازی دیتابیس PostgreSQL و اتصال به پروژه جنگو

محمد بابازاده

قبل از شروع به توسعه پروژه Django نیاز به فضایی برای ذخیره سازی داده های پروژه داریم. در قسمت ۴ از آموزش توسعه سریع وب با Django 2 با استفاده از کانتینر پلتفرم داکر دیتابیس PostgreSQL را راه اندازی خواهیم کرد و کمی در شل دیتابیس دستورات SQL را تمرین خواهیم کرد و سپس با تغییر فایل settings.py در فایل های پروژه جنگو، پروژه را به دیتابیس PostgreSQL متصل خواهیم کرد.

در قسمت قبل (قسمت ۳ – پنل ادمین Django و اپلیکیشن وبلاگ) با راه اندازی پنل ادمین بر روی دیتابیس Sqlite آشنا شدیم و در این قسمت می‌خواهیم از دیتابیس Sqlite به دیتابیس PostgreSQL که دیتابیس بسیار قوی‌تر و قابل اطمینان تری هست مهاجرت کنیم.

مشاهده قسمت ۴ دوره آموزشی توسعه سریع وب با Django 2، راه اندازی دیتابیس PostgreSQL و اتصال به پروژه Django.

در ابتدای ویدیو نگاهی که درصد فراوانی استفاده از دیتابیس های SQL و NoSQL می‌اندازیم.

دیتابیس های SQL و NoSQL

سپس با مطرح‌ترین دیتابیس‌هایی که در حال حاضر در سرویس های عملیاتی دنیا استفاده می‌شوند نظیر MySQL، MongoDB و PostgreSQL آشنا خواهیم شد.

پرطرفدارترین دیتابیس های دنیا

پس از مقایسه و آشنایی با دیتابیس های مطرح حال حاضر، توسط تکنولوژی کانتینر پلتفرم داکر یک دیتابیس PostgreSQL راه اندازی می‌کنیم و وارد شل دیتابیس خواهیم شد تا کمی دستورات SQL را تمرین کنیم.

شل دیتابیس پستگرس

پس از راه اندازی دیتابیس اکنون نوبت آن است که دیتابیس را به پروژه Django متصل کنیم. این کار از طریق فایل settings.py که در فایل های پروژه Django است قابل انجام است و با وارد کردن مشخصات پیکره بندی دیتابیس در پروژه Django می‌توانیم پروژه را به دیتابیس متصل کنیم.

اتصال پروژه جنگو به دیتابیس

اکنون زمان آن است که جرعه آخر فنجان قهوه را بنوشیم و migration را در سطح دیتابیس اعمال کنیم تا جداول مورد نظر پیشفرض جنگو در دیتابیس Postgresql ساخته شود. سپس همانند قسمت قبل وارد پنل ادمین خواهیم شد و کاربر جدیدی را خواهیم ساخت و سپس وجود یا عدم وجود این کاربرها را از طریق شل اسکریپت دیتابیس Postgresql بررسی می‌کنیم تا مطمئن شویم که کاربرها در دیتابیس به خوبی ساخته شده اند.

اتصال دیتابیس به پروژه Django

در قسمت بعد با تحلیل مدل‌های دیتابیس و ساخت مدل‌های پروژه Blogpy آشنا خواهیم شد.

مقالات مرتبط

دیدگاه

20 نظر تاکنون ارسال شده است
  1. سلام استاد من وقتی docker-compose up -d رو میزنم این ارور رو میده بهم :

    Creating msblog_postgresql … error

    ERROR: for msblog_postgresql Cannot start service msblog_postgresql: Ports are not available: unable to list exposed ports: Get http://unix/forwards/list: open \\.\pipe\dockerBackendApiServer: The system cannot find the file specified.

    ERROR: for msblog_postgresql Cannot start service msblog_postgresql: Ports are not available: unable to list exposed ports: Get http://unix/forwards/list: open \\.\pipe\dockerBackendApiServer: The system cannot find the file specified.
    ERROR: Encountered errors while bringing up the project.

    و وقتی که پروژه جنگو رو ران میکنم هم این ارور رو میگیرم :

    could not connect to server: Connection refused (0x0000274D/10061)
    Is the server running on host “localhost” (127.0.0.1) and accepting
    TCP/IP connections on port 5432?

    مشکل این ارور ها چیه؟؟

    • سلام و درود

      خطای دوم که در زمان اجرای پروژه می‌گیرید به این دلیل رخ می‌دهد که دیتابیس روی پورت ۵۴۳۲ در حال Listen کردن نیست و پروژه جنگو نمی‌تواند به دیتابیس متصل بشود. در رابطه با خطای اول فکرمیکنم احتمالا Firewall سیستم‌عامل شما روشن هست و اجازه ی دسترسی به پورت‌های سیستم عامل را نمی‌دهد. لطفا یک‌بار Firewall را خاموش کنید و مجددا امتحان کنید و نتیجه را اطلاع دهید.
      موفق باشید

  2. سلام وقت بخیر
    دقیقا طبق آموزش های توسعه سریع وب با جانگو 2 فایل های docker-compose.yml و .env رو ایجاد کردم و کانتینر بدون مشکل استارت میشه اما وقتی می خوام دستور زیر رو اجرا کنم بهم ارور میده
    docker exec -it blogpy_postgresql psql -U postgres -W postgres
    متن ارور:
    psql: error: could not connect to server: FATAL: role “postgres” does not exist
    نام دیتابیس، نام کاربری و پسورد کاملا درسته.

  3. سلام
    اقای باباززاده من همه مراحل رو اجرا کردم در اخر وقتی run رو زدم
    این پیامها رو نمایش داد http://uupload.ir/files/v1ut_capture.jpg

    اینم بگم که من توی این قسمت اموزشتون ارور زیاد داشتم و برای رفع این کارها رو کردم:
    1- داکر رو switch to windows containers کردم
    2-در تنظیمات داکر experimental”: true” قرار دادم

    • سلام و درود، وقت بخیر

      دوست عزیز اگر از لاگ خطا را به صورت کامل بدید میتونم کمکتون کنم. متاسفانه در این لاگ اطلاعات مهمی برای خطایابی مشاهده نمیشود.
      موفق باشید

    • سلام وقت بخیر
      http://uupload.ir/view/25ij_django.txt/http://uupload.ir/view/25ij_django.txt
      این فایل لاگ خطا به طور کامل هست.
      مممنون میشم یه نگاهی بندازید.

      یه سوال دیگه
      وقتی داکر و pycharm رو اجرا میکنم لپتاپم خیلی کند میشه (رم لپتاپم4گیگه) و حتی بعضی وقتا هنگ میکنه
      اگه بخاطر داکر هست میتونم بجاش خود postgres رو نصب کنم؟میتونم با آموزشتان پیش برم؟

      • سلام روز بخیر

        ارور اصلی که در حال حاضر به شما داده میشه LookupError: No installed app with label ‘admin’. هست و باید این رو سرچ کنید تا مشکل رو برطرف کنید. این مشکل دلیل واضح و مشخصی نداره و به دلایل متعددی ممکنه این مشکل به وجود بیاد. لینک stackoverflow زیر رو مشاهده کنید:
        “No installed app with label ‘admin’” running Django migration. The app is installed correctly
        من هم قبلا با این مشکل به تعداد دفعات زیادی برخورد کردم، باید راه های مختلفی که گفتند رو تست کنید یا پروژه رو مجددا بسازید تا این مشکل برطرف بشه. همونطور که خدمتتون عرض کردم دلیل به وجود آمدن این مشکل چیزهای متفاوتی میتونه باشه و نسخه قطعی و یکسانی نداره که خدمتتون بگم. با آزمون و خطا میتونید حلش کنید.
        در رابطه با سوال دوم، ۴ گیگ رم برای یک لپ تاپ ویندوز که سیستم عامل ویندوز تقریبا ۱ الی ۲ گیگ رم استفاده میکنه کم هست و برای اجرای داکر مناسب نیست. بهتره postgres رو در سطح سیستم عامل ویندوز نصب کنید و استفاده کنید. از نظر کاربرد هیچ تفاوتی وجود ندارد و داکر تنها روش جدیدتر و بهتری برای اجرای دیتابیس هست. میتونید دیتابیس رو در ویندوز نصب کنید و ادامه آموزش ها رو ببینید و مشکلی از این نظر نخواهد بود.
        موفق باشید

  4. سلام وقتتون بخیر استاد عذر میخوام من دستور docker-compose up -d رو میزنم ارر Can’t find a suitable configuration file in this directory or any parent. Are you in the right directory? Supported filenames: docker-compose.yml, docker-compose.yaml اینرو میده.فک کنم ادرس دایرکتوری ر. نمیتونه پیدا کن.در ویندوز نصب کردم ادرس خود فایل yml رو که در پوشه پروزه جنگو هست رو بهش دادم

    • سلام و درود
      سعی کنید با دستور cd وارد دایرکتوری پروژه بشید و سپس دستور docker-compose up -d رو اجرا کنید. با پارامتر f- میتونید از path هم استفاده کنید.
      موفق و پایدار باشید

  5. سلام من موقع اجرای کامند docker exec -it blogpy_postgresql psql -U postgres -W postgres به اینم ارور برخوردم که
    psql: error: could not connect to server: FATAL: role “postgres” does not exist
    واینکه داخل ویندوز کار میکنم و postgres نصب نیست از قبل
    تو کامنت ها دیدم همین سوال رو پرسیده بودن اما متوجه نشدم چجوری رفع کنم این ارور رو

    • سلام و درود
      احتمالا دیتابیس به درستی راه اندازی نشده دوست عزیز.
      موفق و پایدار باشید

  6. سلام وقت بخیر

    موقع اجرای دستور docker-compose up -d با خطای زیر مواجه میشم

    ERROR: Named volume “aghilpadash_postgresql:/var/lib/postgresql/data:rw” is used in service “aghilpadash_postgre

    sql” but no declaration was found in the volumes section.

    راه حل هم تقریبا پیدا نکردم

    نمیدونم چه کار باید کرد ؟

    ممنون میشم راهنمایی کنید

    • سلام وقت بخیر، باید volume رو تعریف کنید تا داکر کامپوز به خوبی بیاد بالا. لطفا سوالتون رو در گروه های تلگرامی نظیر DevOpsExpertGroup@ بپرسید تا سریع تر پاسخ بگیرید. موفق و پایدار باشید

  7. با سلام من وقتی دستور داکر کامپوز آپ را میزنم این ارور را میده و خیلی سعی کردم رف مشکل کنم که نشد در محیط لینوکس هم کار میکنم.The Compose file ‘./docker-compose.yml’ is invalid because:
    Invalid top-level property “network”. Valid top-level sections for this Compose file are: version, volumes, configs, services, networks, secrets, and extensions starting with “x-“.

    You might be seeing this error because you’re using the wrong Compose file version. Either specify a supported version (e.g “2.2” or “3.3”) and place your service definitions under the services key, or omit the version key and place your service definitions at the root of the file to use version 1.
    For more on the Compose file format versions, see https://docs.docker.com/compose/compose-file/

    • سلام وقت بخیر، ظاهرا ورژن داکر کامپوز شما درست نیست و به همین دلیل خطا میگیرید. لطفا سوالتون رو در گروه های تلگرامی نظیر DevOpsExpertGroup@ بپرسید تا سریع تر پاسخ بگیرید. موفق و پایدار باشید

  8. سلام اقای بابازاده
    بنده چندین مشکل دارم
    1- دیروز من وقتی در اوبنتو از python3 manage.py runserver نتیجه میداد و سرور ران میشد اما امروز که امتحان میکنم با چنین متونی مواجه میشم $ python manage.py runserver
    Watching for file changes with StatReloader
    Performing system checks…

    System check identified no issues (0 silenced).
    Exception in thread Thread-1:
    Traceback (most recent call last):
     File “/home/ab2/.local/lib/python3.8/site-packages/django/db/backends/base/base.py”, line 217, in ensure_connection
      self.connect()
     File “/home/ab2/.local/lib/python3.8/site-packages/django/db/backends/base/base.py”, line 195, in connect
      self.connection = self.get_new_connection(conn_params)
     File “/home/ab2/.local/lib/python3.8/site-packages/django/db/backends/postgresql/base.py”, line 178, in get_new_connection
      connection = Database.connect(**conn_params)
     File “/home/ab2/.local/lib/python3.8/site-packages/psycopg2/__init__.py”, line 127, in connect
      conn = _connect(dsn, connection_factory=connection_factory, **kwasync)
    psycopg2.OperationalError: could not connect to server: Connection refused
        Is the server running on host “localhost” (127.0.0.1) and accepting
        TCP/IP connections on port 5432?
    could not connect to server: Connection refused
        Is the server running on host “localhost” (127.0.0.1) and accepting
        TCP/IP connections on port 5432?

    The above exception was the direct cause of the following exception:

    Traceback (most recent call last):
     File “/usr/lib/python3.8/threading.py”, line 932, in _bootstrap_inner
      self.run()
     File “/usr/lib/python3.8/threading.py”, line 870, in run
      self._target(*self._args, **self._kwargs)
     File “/home/ab2/.local/lib/python3.8/site-packages/django/utils/autoreload.py”, line 54, in wrapper
      fn(*args, **kwargs)
     File “/home/ab2/.local/lib/python3.8/site-packages/django/core/management/commands/runserver.py”, line 120, in inner_run
      self.check_migrations()
     File “/home/ab2/.local/lib/python3.8/site-packages/django/core/management/base.py”, line 453, in check_migrations
      executor = MigrationExecutor(connections[DEFAULT_DB_ALIAS])
     File “/home/ab2/.local/lib/python3.8/site-packages/django/db/migrations/executor.py”, line 18, in __init__
      self.loader = MigrationLoader(self.connection)
     File “/home/ab2/.local/lib/python3.8/site-packages/django/db/migrations/loader.py”, line 49, in __init__
      self.build_graph()
     File “/home/ab2/.local/lib/python3.8/site-packages/django/db/migrations/loader.py”, line 212, in build_graph
      self.applied_migrations = recorder.applied_migrations()
     File “/home/ab2/.local/lib/python3.8/site-packages/django/db/migrations/recorder.py”, line 73, in applied_migrations
      if self.has_table():
     File “/home/ab2/.local/lib/python3.8/site-packages/django/db/migrations/recorder.py”, line 56, in has_table
      return self.Migration._meta.db_table in self.connection.introspection.table_names(self.connection.cursor())
     File “/home/ab2/.local/lib/python3.8/site-packages/django/db/backends/base/base.py”, line 256, in cursor
      return self._cursor()
     File “/home/ab2/.local/lib/python3.8/site-packages/django/db/backends/base/base.py”, line 233, in _cursor
      self.ensure_connection()
     File “/home/ab2/.local/lib/python3.8/site-packages/django/db/backends/base/base.py”, line 217, in ensure_connection
      self.connect()
     File “/home/ab2/.local/lib/python3.8/site-packages/django/db/utils.py”, line 89, in __exit__
      raise dj_exc_value.with_traceback(traceback) from exc_value
     File “/home/ab2/.local/lib/python3.8/site-packages/django/db/backends/base/base.py”, line 217, in ensure_connection
      self.connect()
     File “/home/ab2/.local/lib/python3.8/site-packages/django/db/backends/base/base.py”, line 195, in connect
      self.connection = self.get_new_connection(conn_params)
     File “/home/ab2/.local/lib/python3.8/site-packages/django/db/backends/postgresql/base.py”, line 178, in get_new_connection
      connection = Database.connect(**conn_params)
     File “/home/ab2/.local/lib/python3.8/site-packages/psycopg2/__init__.py”, line 127, in connect
      conn = _connect(dsn, connection_factory=connection_factory, **kwasync)
    django.db.utils.OperationalError: could not connect to server: Connection refused
        Is the server running on host “localhost” (127.0.0.1) and accepting
        TCP/IP connections on port 5432?
    could not connect to server: Connection refused
        Is the server running on host “localhost” (127.0.0.1) and accepting
        TCP/IP connections on port 5432?

    /mnt/c/Users/AB2/Desktop/DJ/blogfy/blogfy/settings.py changed, reloading.
    Watching for file changes with StatReloader
    Performing system checks…

    System check identified no issues (0 silenced).
    Exception in thread Thread-1:
    Traceback (most recent call last):
     File “/home/ab2/.local/lib/python3.8/site-packages/django/db/backends/base/base.py”, line 217, in ensure_connection
      self.connect()
     File “/home/ab2/.local/lib/python3.8/site-packages/django/db/backends/base/base.py”, line 195, in connect
      self.connection = self.get_new_connection(conn_params)
     File “/home/ab2/.local/lib/python3.8/site-packages/django/db/backends/postgresql/base.py”, line 178, in get_new_connection
      connection = Database.connect(**conn_params)
     File “/home/ab2/.local/lib/python3.8/site-packages/psycopg2/__init__.py”, line 127, in connect
      conn = _connect(dsn, connection_factory=connection_factory, **kwasync)
    psycopg2.OperationalError: could not connect to server: Connection refused
        Is the server running on host “localhost” (127.0.0.1) and accepting
        TCP/IP connections on port 5432?
    could not connect to server: Connection refused
        Is the server running on host “localhost” (127.0.0.1) and accepting
        TCP/IP connections on port 5432?

    The above exception was the direct cause of the following exception:

    Traceback (most recent call last):
     File “/usr/lib/python3.8/threading.py”, line 932, in _bootstrap_inner
      self.run()
     File “/usr/lib/python3.8/threading.py”, line 870, in run
      self._target(*self._args, **self._kwargs)
     File “/home/ab2/.local/lib/python3.8/site-packages/django/utils/autoreload.py”, line 54, in wrapper
      fn(*args, **kwargs)
     File “/home/ab2/.local/lib/python3.8/site-packages/django/core/management/commands/runserver.py”, line 120, in inner_run
      self.check_migrations()
     File “/home/ab2/.local/lib/python3.8/site-packages/django/core/management/base.py”, line 453, in check_migrations
      executor = MigrationExecutor(connections[DEFAULT_DB_ALIAS])
     File “/home/ab2/.local/lib/python3.8/site-packages/django/db/migrations/executor.py”, line 18, in __init__
      self.loader = MigrationLoader(self.connection)
     File “/home/ab2/.local/lib/python3.8/site-packages/django/db/migrations/loader.py”, line 49, in __init__
      self.build_graph()
     File “/home/ab2/.local/lib/python3.8/site-packages/django/db/migrations/loader.py”, line 212, in build_graph
      self.applied_migrations = recorder.applied_migrations()
     File “/home/ab2/.local/lib/python3.8/site-packages/django/db/migrations/recorder.py”, line 73, in applied_migrations
      if self.has_table():
     File “/home/ab2/.local/lib/python3.8/site-packages/django/db/migrations/recorder.py”, line 56, in has_table
      return self.Migration._meta.db_table in self.connection.introspection.table_names(self.connection.cursor())
     File “/home/ab2/.local/lib/python3.8/site-packages/django/db/backends/base/base.py”, line 256, in cursor
      return self._cursor()
     File “/home/ab2/.local/lib/python3.8/site-packages/django/db/backends/base/base.py”, line 233, in _cursor
      self.ensure_connection()
     File “/home/ab2/.local/lib/python3.8/site-packages/django/db/backends/base/base.py”, line 217, in ensure_connection
      self.connect()
     File “/home/ab2/.local/lib/python3.8/site-packages/django/db/utils.py”, line 89, in __exit__
      raise dj_exc_value.with_traceback(traceback) from exc_value
     File “/home/ab2/.local/lib/python3.8/site-packages/django/db/backends/base/base.py”, line 217, in ensure_connection
      self.connect()
     File “/home/ab2/.local/lib/python3.8/site-packages/django/db/backends/base/base.py”, line 195, in connect
      self.connection = self.get_new_connection(conn_params)
     File “/home/ab2/.local/lib/python3.8/site-packages/django/db/backends/postgresql/base.py”, line 178, in get_new_connection
      connection = Database.connect(**conn_params)
     File “/home/ab2/.local/lib/python3.8/site-packages/psycopg2/__init__.py”, line 127, in connect
      conn = _connect(dsn, connection_factory=connection_factory, **kwasync)
    django.db.utils.OperationalError: could not connect to server: Connection refused
        Is the server running on host “localhost” (127.0.0.1) and accepting
        TCP/IP connections on port 5432?
    could not connect to server: Connection refused
        Is the server running on host “localhost” (127.0.0.1) and accepting
        TCP/IP connections on port 5432?

    /mnt/c/Users/AB2/Desktop/DJ/blogfy/blogfy/settings.py changed, reloading.
    Watching for file changes with StatReloader
    Performing system checks…

    System check identified no issues (0 silenced).
    Exception in thread Thread-1:
    Traceback (most recent call last):
     File “/home/ab2/.local/lib/python3.8/site-packages/django/db/backends/base/base.py”, line 217, in ensure_connection
      self.connect()
     File “/home/ab2/.local/lib/python3.8/site-packages/django/db/backends/base/base.py”, line 195, in connect
      self.connection = self.get_new_connection(conn_params)
     File “/home/ab2/.local/lib/python3.8/site-packages/django/db/backends/postgresql/base.py”, line 178, in get_new_connection
      connection = Database.connect(**conn_params)
     File “/home/ab2/.local/lib/python3.8/site-packages/psycopg2/__init__.py”, line 127, in connect
      conn = _connect(dsn, connection_factory=connection_factory, **kwasync)
    psycopg2.OperationalError: could not connect to server: Connection refused
        Is the server running on host “localhost” (127.0.0.1) and accepting
        TCP/IP connections on port 5432?
    could not connect to server: Connection refused
        Is the server running on host “localhost” (127.0.0.1) and accepting
        TCP/IP connections on port 5432?

    The above exception was the direct cause of the following exception:

    Traceback (most recent call last):
     File “/usr/lib/python3.8/threading.py”, line 932, in _bootstrap_inner
      self.run()
     File “/usr/lib/python3.8/threading.py”, line 870, in run
      self._target(*self._args, **self._kwargs)
     File “/home/ab2/.local/lib/python3.8/site-packages/django/utils/autoreload.py”, line 54, in wrapper
      fn(*args, **kwargs)
     File “/home/ab2/.local/lib/python3.8/site-packages/django/core/management/commands/runserver.py”, line 120, in inner_run
      self.check_migrations()
     File “/home/ab2/.local/lib/python3.8/site-packages/django/core/management/base.py”, line 453, in check_migrations
      executor = MigrationExecutor(connections[DEFAULT_DB_ALIAS])
     File “/home/ab2/.local/lib/python3.8/site-packages/django/db/migrations/executor.py”, line 18, in __init__
      self.loader = MigrationLoader(self.connection)
     File “/home/ab2/.local/lib/python3.8/site-packages/django/db/migrations/loader.py”, line 49, in __init__
      self.build_graph()
     File “/home/ab2/.local/lib/python3.8/site-packages/django/db/migrations/loader.py”, line 212, in build_graph
      self.applied_migrations = recorder.applied_migrations()
     File “/home/ab2/.local/lib/python3.8/site-packages/django/db/migrations/recorder.py”, line 73, in applied_migrations
      if self.has_table():
     File “/home/ab2/.local/lib/python3.8/site-packages/django/db/migrations/recorder.py”, line 56, in has_table
      return self.Migration._meta.db_table in self.connection.introspection.table_names(self.connection.cursor())
     File “/home/ab2/.local/lib/python3.8/site-packages/django/db/backends/base/base.py”, line 256, in cursor
      return self._cursor()
     File “/home/ab2/.local/lib/python3.8/site-packages/django/db/backends/base/base.py”, line 233, in _cursor
      self.ensure_connection()
     File “/home/ab2/.local/lib/python3.8/site-packages/django/db/backends/base/base.py”, line 217, in ensure_connection
      self.connect()
     File “/home/ab2/.local/lib/python3.8/site-packages/django/db/utils.py”, line 89, in __exit__
      raise dj_exc_value.with_traceback(traceback) from exc_value
     File “/home/ab2/.local/lib/python3.8/site-packages/django/db/backends/base/base.py”, line 217, in ensure_connection
      self.connect()
     File “/home/ab2/.local/lib/python3.8/site-packages/django/db/backends/base/base.py”, line 195, in connect
      self.connection = self.get_new_connection(conn_params)
     File “/home/ab2/.local/lib/python3.8/site-packages/django/db/backends/postgresql/base.py”, line 178, in get_new_connection
      connection = Database.connect(**conn_params)
     File “/home/ab2/.local/lib/python3.8/site-packages/psycopg2/__init__.py”, line 127, in connect
      conn = _connect(dsn, connection_factory=connection_factory, **kwasync)
    django.db.utils.OperationalError: could not connect to server: Connection refused
        Is the server running on host “localhost” (127.0.0.1) and accepting
        TCP/IP connections on port 5432?
    could not connect to server: Connection refused
        Is the server running on host “localhost” (127.0.0.1) and accepting
        TCP/IP connections on port 5432?
    فایروال هم خاموشه

    2-وقتی در vscode و pycharm جهت ران کردن سور استفاده میکنم با مشکل زیر مواجه میشم
    C:\Users\AB2\Desktop\DJ\Seyed\Scripts\python.exe C:/Users/AB2/Desktop/DJ/blogfy/manage.py
    Traceback (most recent call last):
     File “C:\Users\AB2\Desktop\DJ\blogfy\manage.py”, line 10, in main
      from django.core.management import execute_from_command_line
    ModuleNotFoundError: No module named ‘django’

    The above exception was the direct cause of the following exception:

    Traceback (most recent call last):
     File “C:\Users\AB2\Desktop\DJ\blogfy\manage.py”, line 21, in <module>
      main()
     File “C:\Users\AB2\Desktop\DJ\blogfy\manage.py”, line 12, in main
      raise ImportError(
    ImportError: Couldn’t import Django. Are you sure it’s installed and available on your PYTHONPATH environment variable? Did you forget to activate a virtual environment?

    Process finished with exit code 1
    علتش این دو تا چیه

    یه انتقادی هم دارم به روند تدریس و دوره
    اینکه برخی اصطلاحات و موضوعات باز نمیشه و بیان برخی دستورات کمی گنگه و به صورت خوب باز میشه تا برای مخاطب جا بیافته
    در مجموع دوره مفیدیه
    ممنون میشم بابت این دو مشکل کمکم کنید

    • سلام، وقت بخیر
      لطفا در گروه تلگرامی https://t.me/djangoir سوالات فنی رو بپرسید، اساتید بسیاری حضور دارند و دوستان رو راهنمایی میکنند و بنده هم فرصت کنم در گروه به سوالات فنی پاسخ میدم.
      موفق و پایدار باشید

  9. سلام خسته نباشید من موقعی که دستور docker-compose up -d وارد میکنیم این ارور میاد داخل گوگل هم جتست وجو کردم ولی نتونستم مشکلو حل کنم اگه میشه راهنمایی کنید

    این ارور میاد:

    ERROR: toomanyrequests: You have reached your pull rate limit. You may increase the limit by authenticating and upgrading: https://www.docker.com/increase-rate-limit

    • سلام، وقت بخیر
      لطفا این سوال رو در گروه https://t.me/djangoir بپرسید، بنده به همراه دوستان میتونیم سریعتر پاسخگو باشیم.
      موفق و پایدار باشید